//Zombie board header file
//
//Copyright 2005 Dennis Clark and TTT Enterprises
//All rights reserved, you are free to use this code as long as 
//you tell everyone where you got it.

//*********************
// Defs and macros
//*********************
#define S_10us 		65535 - 100					//10us timeout (100 clock tics)
#define FULLUP		74							//pulse width check numbers
#define	HALFUP		94	
#define CENTER		114
#define	FULLDOWN	154
#define	HALFDOWN	134
#define FULLLEFT	74	
#define FULLRIGHT	154
#define	HALFLEFT	94
#define HALFRIGHT	134
	
enum {
	SET_C1,
	READ_C1,
	SET_C2,
	READ_C2,
	SET_C3,
	READ_C3,
	RUALIVE
};

//Zombie Board Defs
#define MODE_LED_ON		output_bit(PIN_A0,1)
#define MODE_LED_OFF	output_bit(PIN_A0,0)
#define UNIT_LED_ON		output_bit(PIN_A1,1)
#define UNIT_LED_OFF	output_bit(PIN_A1,0)
#define CHA_INPUT	PIN_A2
#define CHB_INPUT	PIN_A3
#define REM_AUTO		input(PIN_A4)
#define SET_BTN			input(PIN_A5)

#define LIGHTA_ON		output_bit(PIN_B0,1)
#define LIGHTA_OFF		output_bit(PIN_B0,0)
#define LIGHTB_ON		output_bit(PIN_B1,1)
#define LIGHTB_OFF		output_bit(PIN_B1,0)
#define LIGHTC_ON		output_bit(PIN_B2,1)
#define LIGHTC_OFF		output_bit(PIN_B2,0)
#define LIGHTD_ON		output_bit(PIN_B3,1)
#define LIGHTD_OFF		output_bit(PIN_B3,0)
#define	RELAY_ON		output_bit(PIN_B4,1)
#define	RELAY_OFF		output_bit(PIN_B4,0)
#define AUDIO_ON		output_bit(PIN_B5,1)
#define AUDIO_OFF		output_bit(PIN_B5,0)

#define	CHC_INPUT	PIN_C0
#define DIR_2		PIN_C3
#define DIR_1		PIN_C4
#define SPKR		PIN_C5

//useful defs in memory
unsigned char STATUS;						//STATUS register
#locate STATUS=0xFD8

unsigned char BSR;							//BSR (duh) register
#locate BSR=0xFE0

unsigned char RCREG;						//USART receive register
#locate RCREG=0xFAE

unsigned char TXREG;						//USART Xmit register
#locate TXREG=0xFAD

unsigned char TXSTA;						//Xmit status register
#locate TXSTA=0xFAC
struct{
	unsigned char TX9D:1;
	unsigned char TRMT:1;
	unsigned char BRGH:1;
	unsigned char UI3:1;
	unsigned char SYNC:1;
	unsigned char TXEN:1;
	unsigned char TX9:1;
	unsigned char CSRC:1;
}TXSTAbits;
#locate TXSTAbits=0xFAC

unsigned char RCSTA;						//USART receive status register
#locate RCSTA=0xFAB
struct{
	unsigned char RX9D:1;
	unsigned char OERR:1;
	unsigned char FERR:1;
	unsigned char ADDEN:1;
	unsigned char CREN:1;
	unsigned char SREN:1;
	unsigned char RX9:1;
	unsigned char SPEN:1;
}RCSTAbits;
#locate RCSTAbits=0xFAB

unsigned char TMR0L;
#locate TMR0L=0xFD6							//Timer0 lower byte

unsigned char T0CON;
#locate T0CON=0xFD5							//Timer0 config register

unsigned char TMR1L;
#locate TMR1L=0xFCE
unsigned char TMR1H;
#locate TMR1H=0xFCF

unsigned char INTCON;
#locate INTCON=0xFF2						//IRQ register
struct {
	unsigned char RBIF:1;
	unsigned char INT0IF:1;
	unsigned char TMR0IF:1;
	unsigned char RBIE:1;
	unsigned char INT0IE:1;
	unsigned char TMR0IE:1;
	unsigned char GIEL:1;
	unsigned char GIEH:1;
}INTCONbits;
#locate INTCONbits=0xFF2

unsigned char INTCON2;
#locate INTCON2=0xFF1
struct {
	unsigned char RBIP:1;
	unsigned char UNUSED:1;
	unsigned char TMR0IP:1;
	unsigned char UNUSED2:1;
	unsigned char INTEDG2:1;
	unsigned char INTEDG1:1;
	unsigned char INTEDG0:1;
	unsigned char RBPU:1;
}INTCON2bits;
#locate INTCON2bits=0xFF1	

unsigned char PIE1;
#locate PIE1=0xF9D
struct{
	unsigned char TMR1IE:1;
	unsigned char TMR2IE:1;
	unsigned char CCP1IE:1;
	unsigned char SSPIE:1;
	unsigned char TXIE:1;
	unsigned char RCIE:1;
	unsigned char ADIE:1;
	unsigned char PSPIE:1;
}PIE1bits;
#locate PIE1bits=0xF9D

unsigned char PIR1;
#locate PIR1=0xF9E
struct {
	unsigned char TMR1IF:1;
	unsigned char TMR2IF:1;
	unsigned char CCP1IF:1;
	unsigned char SSPIF:1;
	unsigned char TXIF:1;
	unsigned char RCIF:1;
	unsigned char ADIF:1;
	unsigned char PSPIF:1;
}PIR1bits;
#locate PIR1bits=0xF9E	

unsigned char IPR1;
#locate IPR1=0xF9F
struct {
	unsigned char TMR1IP:1;
	unsigned char TMR2IP:1;
	unsigned char CCP1IP:1;
	unsigned char SSPIP:1;
	unsigned char TXIP:1;
	unsigned char RCIP:1;
	unsigned char ADIP:1;
	unsigned char PSPIP:1;
}IPR1bits;
#locate IPR1bits=0xF9F	

unsigned char PIR2;
#locate PIR2=0xFA1
struct {
	unsigned char CCP2IF:1;
	unsigned char TMR3IF:1;
	unsigned char LVDIF:1;
	unsigned char BCLIF:1;
	unsigned char EEIF:1;
	unsigned char NA5:1;
	unsigned char NA6:1;
	unsigned char NA7:1;
}PIR2bits;
#locate PIR2bits=0xFA1

unsigned char IPR2;
#locate IPR2=0xFA2

unsigned char RCON;
#locate RCON=0xFD0
struct {
	unsigned char NBOR:1;
	unsigned char NPOR:1;
	unsigned char NPD:1;
	unsigned char NTO:1;
	unsigned char NRI:1;
	unsigned char NU:2;
	unsigned char IPEN:1;
} RCONbits;
#locate RCONbits=0xFD0

unsigned char TMR3L;
#locate TMR3L=0xFB2

unsigned char TMR3H;
#locate TMR3H=0xFB3
